JSON._types={};
JSON._stringify=JSON.stringify;
JSON._stringifyRecursive=(obj)->
    for key of obj
        found=false
        for typeName of JSON._types
            type=JSON._types[typeName];
            if type.check.call obj[key]
                found=true
                obj[key]=
                    "@#{typeName}@":type.serialize.call obj[key]
        if !found && typeof obj[key]=='object'
            obj[key]=JSON._stringifyRecursive obj[key]
    obj
JSON.stringify = (obj) ->
    obj=JSON._stringifyRecursive obj
    JSON._stringify obj
JSON._parse=JSON.parse
JSON._parseRecursive=(obj)->
    for key of obj
        if typeof obj[key]=='object'
            obj[key]=JSON._parseRecursive obj[key]
        else
            if key[0]=='@' && key[key.length-1]=='@'
                type=key.substr 1,key.length-2
                if JSON._types[type]
                    deserialized=JSON._types[type].deserialize.call obj[key]
                    return deserialized if deserialized
    obj
JSON.parse=(string)->
    obj=JSON._parse string
    if !!((string.indexOf '@')+1)
        obj = JSON._parseRecursive obj
    obj

JSON.defineType=(name,{serialize,deserialize,check})->
    JSON._types[name]=
        serialize:serialize
        deserialize:deserialize
        check:check

JSON.defineType 'date',
    serialize:       -> do @.getTime
    deserialize:     -> new Date @
    check:           -> @ instanceof Date

JSON.defineType 'binary',
    serialize:       -> @.toString 'base64'
    deserialize:     -> new Buffer @, 'base64'
    check:           -> @ instanceof Buffer

JSON.defineType 'function',
    serialize:       -> do @.toString
    deserialize:     -> new Function("return " + @)()
    check:           -> typeof @=='function'
