// Generated by CoffeeScript 1.10.0
(function() {
  JSON._types = {};

  JSON._stringify = JSON.stringify;

  JSON._stringifyRecursive = function(obj) {
    var found, key, obj1, type, typeName;
    for (key in obj) {
      found = false;
      for (typeName in JSON._types) {
        type = JSON._types[typeName];
        if (type.check.call(obj[key])) {
          found = true;
          obj[key] = (
            obj1 = {},
            obj1["@" + typeName + "@"] = type.serialize.call(obj[key]),
            obj1
          );
        }
      }
      if (!found && typeof obj[key] === 'object') {
        obj[key] = JSON._stringifyRecursive(obj[key]);
      }
    }
    return obj;
  };

  JSON.stringify = function(obj) {
    obj = JSON._stringifyRecursive(obj);
    return JSON._stringify(obj);
  };

  JSON._parse = JSON.parse;

  JSON._parseRecursive = function(obj) {
    var deserialized, key, type;
    for (key in obj) {
      if (typeof obj[key] === 'object') {
        obj[key] = JSON._parseRecursive(obj[key]);
      } else {
        if (key[0] === '@' && key[key.length - 1] === '@') {
          type = key.substr(1, key.length - 2);
          if (JSON._types[type]) {
            deserialized = JSON._types[type].deserialize.call(obj[key]);
            if (deserialized) {
              return deserialized;
            }
          }
        }
      }
    }
    return obj;
  };

  JSON.parse = function(string) {
    var obj;
    obj = JSON._parse(string);
    if (!!((string.indexOf('@')) + 1)) {
      obj = JSON._parseRecursive(obj);
    }
    return obj;
  };

  JSON.defineType = function(name, arg) {
    var check, deserialize, serialize;
    serialize = arg.serialize, deserialize = arg.deserialize, check = arg.check;
    return JSON._types[name] = {
      serialize: serialize,
      deserialize: deserialize,
      check: check
    };
  };

  JSON.defineType('date', {
    serialize: function() {
      return this.getTime();
    },
    deserialize: function() {
      return new Date(this);
    },
    check: function() {
      return this instanceof Date;
    }
  });

  JSON.defineType('binary', {
    serialize: function() {
      return this.toString('base64');
    },
    deserialize: function() {
      return new Buffer(this, 'base64');
    },
    check: function() {
      return this instanceof Buffer;
    }
  });

  JSON.defineType('function', {
    serialize: function() {
      return this.toString();
    },
    deserialize: function() {
      return new Function("return " + this)();
    },
    check: function() {
      return typeof this === 'function';
    }
  });

}).call(this);
